Index: branches/encoders/code/projects/libdragonfly/encoders.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/encoders.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/encoders.c	(revision 1345)
@@ -54,6 +54,7 @@
 	encoder_buf_index = 0;
 	left_data_buf = 0;
 	right_data_buf= 0;
+
 	left_data = -1;
 	right_data = -1;
 	
@@ -140,7 +141,37 @@
 	timecount = 0;
 }
 
+///////////////////////////////////////////////////////////////////////
+int left_data_at(int index) {
+	int tmp_idx = left_data_idx - index;
+	if (tmp_idx < 0)
+		tmp_idx += BUFFER_SIZE;
+	return left_data_array[tmp_idx];
+}
 
+int right_data_at(int index) {
+	int tmp_idx = right_data_idx - index;
+	if (tmp_idx < 0)
+		tmp_idx += BUFFER_SIZE;
+	return right_data_array[tmp_idx];	
+}
+
+
+int get_dx(char encoder, int index) {
+	int dx, ctr;
+	ctr = 0;
+	dx = 1024;
+	do {
+		if (encoder == LEFT)
+			dx = left_data_at(index+ctr+38) - left_data_at(index+ctr);
+		else
+			dx = right_data_at(index+ctr) - right_data_at(index+ctr+38);
+		ctr++;
+	} while ((dx > 30 || dx < -30) && ctr < 3);
+	if (dx > 30 || dx < -30)
+		return ERR_VEL;
+	return dx;
+}
 /** 
 * @brief Returns the approximated instantaneous velocity of the robot
 * in terms of encoder clicks.
@@ -150,6 +181,7 @@
 * @return The instantaneous velocity for the given wheel.
 */
 int encoder_get_v(char encoder){
+	/*
 	if (encoder == LEFT)
 		return left_data_array_bottom() - left_data_array_top();
 
@@ -156,10 +188,23 @@
 	if (encoder == RIGHT)
 		return right_data_array_top() - right_data_array_bottom();
 
-	return -1; /* TODO: velocity could be -1, use another value for error */
+	return -1;
+	*/
+	int vel1, vel2, tmp;
+	vel1 = get_dx(encoder, 0);
+	vel2 = get_dx(encoder, 1);
+
+	if (vel1 == ERR_VEL && vel2 == ERR_VEL)
+		return ERR_VEL << 1;
+	else if (vel2 == ERR_VEL)
+		return vel1 << 1;
+	else if (vel1 == ERR_VEL) 
+		return vel2 << 1;
+	else
+		return vel1 + vel2;
 }
+/////////////////////////////////////////////////////////////////////////
 
-
 /** 
 * @brief Waits until n encoder reads have occurred.
 * Counter is reset on functions exit.
Index: branches/encoders/code/projects/libdragonfly/lcd.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/lcd.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/lcd.c	(revision 1345)
@@ -1,24 +1,42 @@
-/*
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
 
-lcd-ar2.c - implementation for lcd functions
 
-Author: CMU Robotics Club, Colony Project
-
-This uses SPI.
-
-lcd_init MUST be called before anything can be used.
-
-*/
-
+/**
+ * @file lcd.c
+ * @brief LCD
+ *
+ * Implementation of functions for using the LCD.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
 #include <avr/io.h>
 #include <lcd.h>
 #include <time.h>
 
-#define LCD_RS    PB4 // Command/Data
-#define LCD_RSTB  PE2 // reset line
-#define LCD_CS    PB0
-
-//////lcd defines
+//LCD defines
 #define RST _BV(4)  // pd4 (GPIO)
 #define SCE _BV(0)  // pb0 (~SS)
 #define D_C _BV(5)  // pd5 (GPIO?)
@@ -31,201 +49,15 @@
 #define LCDRESETPORT PORTD
 #define LCDRESETDDR DDRD
 
-// Internal Function Prototypes
-// inialize OLED and SPI
-void OLED_init(void);
-
-// reset Controller
-void Reset_SSD1339(void);
-
-// write command or data
-void write_c(unsigned char out_command);
-void write_d(unsigned char out_data);
-
-// these write data to the OLED on 8 bit data bus,  depends on MCU
-void LCD_out(unsigned char cmd);
-
-// these functions set / clear pins for OLED control lines.  they accecpt a 0 or 1 
-void DC(char stat);
-void RES(char stat);
-void CS(char stat);
-
 void lcd_putbyte(unsigned char b);
 
-void crazycircle (void) {
-/*  int i;
-  // draw 100 random circles
-  for(i = 0;i < 100;i++){
-      write_c(0x86);    // draw circle command
-      write_d(rand() % 130);
-      write_d(rand() % 130);
-      write_d(rand() % 64);
-      write_d(rand());
-      write_d(rand());
-      write_d(rand());
-      write_d(rand());
 
-      delay_ms(10);
-  }
-*/
-}
-
-void OLEDtest (void) {
-  //int   i = 0;
-
-  // Initialize
-  //Initialize();
-  OLED_init();
-
-  delay_ms(120);
-
-  write_c(0x8e);    // clear window command
-  write_d(0);
-  write_d(0);
-  write_d(130);
-  write_d(130);
-
-  delay_ms(100);
-  
-  write_c(0x92);    // fill enable command
-  write_d(0x01); 
-  
-  delay_ms(10);
-
-  crazycircle();
-/*
-  // write directly to ram,  this fills up bottom 1/3 of display with color pattern
-  write_c(0x5c);
-  for (i = 0; i < 2000; i++){
-  write_c(0x5c);  
-   write_d(i);
-   write_d(i);
-   write_d(i);
-  }
-  */
-} 
-
-/**********************************************************
-                      Initialize
-**********************************************************/
-
-void OLED_init(void)
-{
-  // Setup SPI here
-  SPCR = 0x5D; //  enable SPI, master, SPI mode 3
-  DDRB |= 0x06; // enable MOSI and SCK as outputs
-
-  LCD_out(0);
-  DC(0);
-  CS(0);
-  Reset_SSD1339();
-  write_c(0xa0); // Set Re-map / Color Depth
-  write_d(0x34);//0xb4); // 262K 8bit R->G->B
-  write_c(0xa1); // Set display start line
-  write_d(0x00); // 00h start
-  //write_c(0xa2); // Set display offset
-  //write_d(0x80); // 80h start
-  write_c(0xA6); // Normal display
-  write_c(0xad); // Set Master Configuration
-  write_d(0x8e); // DC-DC off & external VcomH voltage & external pre-charge voltage
-  write_c(0xb0); // Power saving mode
-  write_d(0x05);
-  write_c(0xb1); // Set pre & dis_charge
-  write_d(0x11); // pre=1h dis=1h
-  write_c(0xb3); // clock & frequency
-  write_d(0xf0); // clock=Divser+1 frequency=fh
-  write_c(0xbb); // Set pre-charge voltage of color A B C
-  write_d(0xff); // color A  was 1c
-  write_d(0xff); // color B  was 1c
-  write_d(0xff); // color C  was 1c
-  write_c(0xbe); // Set VcomH
-  write_d(0x1f); //
-  write_c(0xc1); // Set contrast current for A B C
-  write_d(0xCa); // Color A was AA
-  write_d(0xD4); // Color B was B4
-  write_d(0xF8); // Color C was C8
-  write_c(0xc7); // Set master contrast
-  write_d(0x0f); // no change
-  write_c(0xca); // Duty
-  write_d(0x7f); // 127+1
-  write_c(0xaf); // Display on
-}
-
-void Reset_SSD1339(void)
-{
-  RES(0);
-  delay_ms(100);
-  RES(1);
-}
-void write_c(unsigned char out_command)
-{
-  DC(0);CS(0);
-  //delay_ms(1);
-  
-  LCD_out(out_command);
- // delay_ms(1);
-  
-  DC(1);
-  // potentially add NOP
-  CS(1);
-
-}
-
-void write_d(unsigned char out_data)
-{
-  DC(1);CS(0);
- // delay_ms(1);
- 
-  LCD_out(out_data);
- // delay_ms(1);
-  DC(1);
-  //potentially add NOP
-  CS(1);
-}
-
-// these functions set / clear pins for LCD control lines.  they accecpt a 0 or 1 
-void DC(char stat)
-{
-	DDRB |= _BV(LCD_RS);				// RS is P0.30, set to output
-	if (stat)	
-		PORTB |= _BV(LCD_RS);
-	else
-		PORTB &= ~(_BV(LCD_RS));
-}
-
-void RES(char stat)
-{
-	DDRE |= _BV(LCD_RSTB);				// RSTB is P0.7, set to output
-	if (stat)	
-		PORTE |= _BV(LCD_RSTB);
-	else
-		PORTE &= ~(_BV(LCD_RSTB));
-}
-
-void CS(char stat)
-{
-	DDRB |= _BV(LCD_CS);				// RSTB is P0.7, set to output
-	if (stat)	
-		PORTB |= _BV(LCD_CS);
-	else
-		PORTB &= ~(_BV(LCD_CS));
-}
-
-// send to the LCD
-void LCD_out(unsigned char cmd)
-{
-	SPDR = cmd;
-    // could also do this via interrupts
-	loop_until_bit_is_set(SPSR, SPIF);
-}
-
-
 //**************************************Old shit below!*****************
 /*
-FontLookup - a lookup table for all characters
+  FontLookup - a lookup table for all characters
 */
 static const unsigned char FontLookup [][5] =
-{
+  {
     { 0x00, 0x00, 0x00, 0x00, 0x00 },  // sp
     { 0x00, 0x00, 0x5f, 0x00, 0x00 },   // !
     { 0x00, 0x07, 0x00, 0x07, 0x00 },   // "
@@ -322,7 +154,7 @@
     { 0x41, 0x41, 0x36, 0x08, 0x00 },   // }
     { 0x02, 0x01, 0x01, 0x02, 0x01 },   // ~
     { 0x55, 0x2A, 0x55, 0x2A, 0x55 },   // del
-};
+  };
 
 
 /**
@@ -338,33 +170,32 @@
  * Initializes the LCD. Must be called before any other
  * LCD functions.
  **/
-void lcd_init(void)
-{
-	LCDDDR |= (SCE | SDI | SCK);
-	LCDRESETDDR |= (RST|D_C);
+void lcd_init(void) {
+  LCDDDR |= (SCE | SDI | SCK);
+  LCDRESETDDR |= (RST|D_C);
 
-	LCDPORT &= ~( SCE | SDI | SCK);
-	LCDRESETPORT &=~(D_C);
+  LCDPORT &= ~( SCE | SDI | SCK);
+  LCDRESETPORT &=~(D_C);
   
-	SPCR |= 0x50;//0b01010000; // no SPI int, SPI en, Master, sample on rising edge, fosc/2
-	SPSR |= 0x01;       // a continuation of the above
+  SPCR |= 0x50;//0b01010000; // no SPI int, SPI en, Master, sample on rising edge, fosc/2
+  SPSR |= 0x01;       // a continuation of the above
 
-	LCDRESETPORT |= RST;
-	delay_ms(10);
-	LCDRESETPORT &= (~RST);
-	delay_ms(100);
-	LCDRESETPORT |= RST;
+  LCDRESETPORT |= RST;
+  delay_ms(10);
+  LCDRESETPORT &= (~RST);
+  delay_ms(100);
+  LCDRESETPORT |= RST;
 	
-    lcd_putbyte( 0x21 );  // LCD Extended Commands.
-    lcd_putbyte( 0xC8 );  // Set LCD Vop (Contrast).
-    lcd_putbyte( 0x06 );  // Set Temp coefficent.
-    lcd_putbyte( 0x13 );  // LCD bias mode 1:48.
-    lcd_putbyte( 0x20 );  // LCD Standard Commands, Horizontal addressing mode.
-    lcd_putbyte( 0x0C );  // LCD in normal mode.
+  lcd_putbyte( 0x21 );  // LCD Extended Commands.
+  lcd_putbyte( 0xC8 );  // Set LCD Vop (Contrast).
+  lcd_putbyte( 0x06 );  // Set Temp coefficent.
+  lcd_putbyte( 0x13 );  // LCD bias mode 1:48.
+  lcd_putbyte( 0x20 );  // LCD Standard Commands, Horizontal addressing mode.
+  lcd_putbyte( 0x0C );  // LCD in normal mode.
 	
-	LCDRESETPORT |= D_C;		//put it in init instead of main
+  LCDRESETPORT |= D_C;		//put it in init instead of main
 	
-	lcd_clear_screen();
+  lcd_clear_screen();
 }
 
 /**
@@ -373,11 +204,11 @@
  * @see lcd_init
  **/
 void lcd_clear_screen( void ) {
-	int i;
-	for (i = 0; i < 504; i++)
-			lcd_putbyte(0x0);
+  int i;
+  for (i = 0; i < 504; i++)
+    lcd_putbyte(0x0);
 	
-	lcd_gotoxy(0,0);
+  lcd_gotoxy(0,0);
 }
 
 /**
@@ -388,37 +219,35 @@
  *
  * @see lcd_init
  **/
-void lcd_putc(char c)
-{
-	int i;
+void lcd_putc(char c) {
+  int i;
 	
-	for (i = 0; i < 5; i++)
-		lcd_putbyte(FontLookup[c-32][i]);
-	lcd_putbyte(0);
+  for (i = 0; i < 5; i++)
+    lcd_putbyte(FontLookup[c-32][i]);
+  lcd_putbyte(0);
 }
 
 /*
-print an entire string to the lcd
+  print an entire string to the lcd
 */
-void lcd_puts(char *s)
-{
-	char *t = s;
-	while (*t != 0)
-	{
-		lcd_putc(*t);
-		t++;
-	}
+void lcd_puts(char *s) {
+  char *t = s;
+  while (*t != 0) {
+    lcd_putc(*t);
+    t++;
+  }
 }
 
 /*
-go to coordinate x, y
-y: vertically - 1 char
-x: horizontally - 1 pixel
+  go to coordinate x, y
+  y: vertically - 1 char
+  x: horizontally - 1 pixel
 
-multiply x by 6 if want to move 1 entire character
+  multiply x by 6 if want to move 1 entire character
 
-origin (0,0) is at top left corner of lcd screen
+  origin (0,0) is at top left corner of lcd screen
 */
+
 /**
  * Move the current cursor position to the one specified.
  * lcd_init must be called before this function may be used.
@@ -428,8 +257,7 @@
  *
  * @see lcd_init
  **/
-void lcd_gotoxy(int x, int y)
-{
+void lcd_gotoxy(int x, int y) {
   LCDRESETPORT &= ~(D_C);
   lcd_putbyte(0x40 | (y & 0x07));
   lcd_putbyte(0x80 | (x & 0x7f));
@@ -437,10 +265,11 @@
 }
 
 /*
-prints an int to the lcd
+  prints an int to the lcd
 
-code adapted from Chris Efstathiou's code (hendrix@otenet.gr)
+  code adapted from Chris Efstathiou's code (hendrix@otenet.gr)
 */
+
 /**
  * Print an integer to the LCD screen.
  * lcd_init must be called before this function may be used.
@@ -450,28 +279,30 @@
  * @see lcd_init
  **/
 void lcd_puti(int value ) {
-	unsigned char lcd_data[6]={'0','0','0','0','0','0' }, position=sizeof(lcd_data), radix=10; 
+  unsigned char lcd_data[6]={'0','0','0','0','0','0' }, position=sizeof(lcd_data), radix=10; 
 
-        /* convert int to ascii  */ 
-        if(value<0) { lcd_putc('-'); value=-value; }    
-        do { position--; *(lcd_data+position)=(value%radix)+'0'; value/=radix;  } while(value); 
+  /* convert int to ascii  */ 
+  if(value<0) { 
+    lcd_putc('-'); 
+    value=-value; 
+  }    
+  do { 
+    position--; 
+    *(lcd_data+position)=(value%radix)+'0'; 
+    value/=radix;  
+  } while(value); 
 
     
-        /* start displaying the number */
-        for(;position<=(sizeof(lcd_data)-1);position++)
-          {
-            
-            lcd_putc(lcd_data[position]);
-          }
+  /* start displaying the number */
+  for(;position<=(sizeof(lcd_data)-1);position++)
+    lcd_putc(lcd_data[position]);
 
-	return;
+  return;
 }
 
 /** @} **/ //end defgroup
 
-void lcd_putbyte(unsigned char b)
-{
-	SPDR = b;
-	while (!(SPSR & 0x80)); /* Wait until SPI transaction is complete */
+void lcd_putbyte(unsigned char b) {
+  SPDR = b;
+  while (!(SPSR & 0x80)); /* Wait until SPI transaction is complete */
 }
-
Index: branches/encoders/code/projects/libdragonfly/time.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/time.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/time.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file time.h
  * @brief Contains time-related functions and definitions
  *
@@ -11,10 +37,6 @@
 #ifndef _TIME_H_
 #define _TIME_H_
 
-/*Maximum # of functions*/
-#define MAX_FUNCTIONS 10
-
-
 /*	Predefined times for prescale_opt in time.c.
 	To make you own, know that a pulse is 1/16th of a second. You cannot get less than this. To get more, you need
 	to know how many 16ths of a second are in the time you want. (Time_desired * 16 = prescaler_opt)
@@ -41,19 +63,12 @@
 /** @brief Delay execution for the specified time **/
 void delay_ms(int ms) ;
 /** @brief Enable the realtime clock **/
-int rtc_multi_init(int* prescale_opt, void (*rtc_fun[])(void), int argc);
+void rtc_init(int prescale_opt, void (*rtc_func)(void));
 /** @brief Reset the counter of the realtime clock **/
 void rtc_reset(void);
 /** @brief Get the value of the realtime clock. **/
 int rtc_get(void);
 
-int rtc_add_function(void (*rtc_f) (void), int prescale_opt);
-
-int rtc_remove_function(void (*rtc_func)(void));
-int rtc_get_function_count(void);
-
-int rtc_init(int prescale_opt, void (*rtc_func)(void));
-
 /** @} **/
 
 #endif
Index: branches/encoders/code/projects/libdragonfly/analog.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/analog.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/analog.h	(revision 1345)
@@ -1,5 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
  * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
+ * 
  * @file analog.h
  * @brief Contains functions and definitions for using the ADC
  * 
@@ -12,11 +37,13 @@
 	
  * @author Colony Project, CMU Robotics Club, based on firefly
  * code by Tom Lauwers
-*/
+ */
 
 #ifndef _ANALOG_H
 #define _ANALOG_H
 
+#include <inttypes.h>
+
 /**
  * @addtogroup analog
  * @{
@@ -43,18 +70,20 @@
 /** @brief Analog port 9 **/
 #define AN9 0x09
 /** @brief Analog port 10 **/
-#define AN10 0x0a
+#define AN10 0x0A
 /** @brief Analog port 11 **/
-#define AN11 0x0b
+#define AN11 0x0B
 /** @brief Analog port 12 **/
-#define AN12 0x0c
+#define AN12 0x0C
 /** @brief Analog port 13 **/
-#define AN13 0x0d
+#define AN13 0x0D
 /** @brief Analog port 14 **/
-#define AN14 0x0e
+#define AN14 0x0E
 /** @brief Analog port 15 **/
-#define AN15 0x0f
+#define AN15 0x0F
 
+/** @brief BOM_PORT analog port for BOM **/
+#define BOM_PORT AN0
 /** @brief EXT_MUX analog port **/
 #define EXT_MUX AN7
 /** @brief Analog port for the wheel **/
@@ -62,15 +91,38 @@
 /** @brief Analog port for the battery voltage detector **/
 #define BATT_PORT  AN11
 
-/** @brief Initialize analog ports. **/
-void analog_init(void);
-/** @brief Read an 8-bit number from an analog port. **/
+#define ADC_START 1
+#define ADC_STOP 0
+
+#define ADMUX_OPT 0x60
+
+/** @brief Struct to hold the value of a particular analog port **/
+typedef struct {
+  uint8_t adc8;
+  uint16_t adc10;
+} adc_t;
+
+
+/** @brief Initialize analog ports. Will start running a loop
+    if start_conversion is ADC_START.**/
+void analog_init(int start_conversion);
+/** @brief starts the analog loop. Doesn't do anything if the loop is already running. **/
+void analog_start_loop(void);
+/** @brief Stops the analog loop. Doesn't do anything if the loop is already stopped. **/
+void analog_stop_loop(void);
+/** @brief Returns an 8-bit analog value from the look up table. Use this instead of analog_get8. **/
 unsigned int analog8(int which);
-/** @brief Read a 10-bit number from an analog port. **/
+/** @brief Returns an 10-bit analog value from the look up table. Use this instead of analog_get10. **/
 unsigned int analog10(int which);
 /** @brief Read the position of the wheel. **/
 int wheel(void);
+/** @brief Read an 8-bit number from an analog port. Loop must be stopped for this to work. **/
+unsigned int analog_get8(int which);
+/** @brief Read a 10-bit number from an analog port. Loop must be stopped for this to work. **/
+unsigned int analog_get10(int which);
 
+
 /**@}**/ //end group
 
 #endif
+
Index: branches/encoders/code/projects/libdragonfly/move.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/move.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/move.c	(revision 1345)
@@ -1,3 +1,38 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file move.c
+ * @brief Functions for moving
+ *
+ * Implementation of functions for moving the robot.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
 #include "dragonfly_lib.h"
 
 #include "move.h"
@@ -8,8 +43,7 @@
 void translateAngulartoLinear (int velocity, int omega, int* vl, int* vr);
 
 // global varaibles for move_avoid
-int d1, d2, d3, d4, d5;
-
+int d1, d2, d3, d4, d5; 
 /**
  * @defgroup move Movement
  * @brief Functions fo controlling robot motion
@@ -70,7 +104,7 @@
  *
  * @see motors_init, range_init, move
  **/
-void move_avoid(int velocity, int omega, int strength){
+void move_avoid(int velocity, int omega, int strength) {
   int pControl;
   int vl = 0;
   int vr = 0;
@@ -92,12 +126,12 @@
   d5=(temp == -1) ? d5 : temp;
   
   /* Avoid obstacles ahead
-  if(d2>170)
-    v*=-1;
+     if(d2>170)
+     v*=-1;
     
-  Naturally slow down if there is something in the way.
-  if(d2>150 || d1>180 || d3>180){
-    v>>=1;
+     Naturally slow down if there is something in the way.
+     if(d2>150 || d1>180 || d3>180){
+     v>>=1;
   */
   
   //pControl= (((d3-d1) + (d4-d5))*strength)/100;
@@ -120,9 +154,9 @@
 /**@}**///end the motion group
 
 void translateAngulartoLinear (int velocity, int omega, int* vl, int* vr) {
-	//omega: angle measure, positive couter-clockwise from front.
-	// -180 <= omega <= 180
-	//velocity: -255 <= velocity <= 255
+  //omega: angle measure, positive couter-clockwise from front.
+  // -180 <= omega <= 180
+  //velocity: -255 <= velocity <= 255
   
   long int vltemp, vrtemp;
   
@@ -130,17 +164,17 @@
   if (velocity < -255 || velocity >255 || omega < -255 || omega > 255) return;
 	
   //compute
-	vrtemp = velocity + omega * 3;
-	vltemp = velocity - omega * 3;
+  vrtemp = velocity + omega * 3;
+  vltemp = velocity - omega * 3;
 	
-	//check to see if max linear velocities have been exceeded.
+  //check to see if max linear velocities have been exceeded.
   if (vrtemp > 255) {
     vltemp = 255 * vltemp / vrtemp;
     vrtemp = 255;
   }
   if (vltemp > 255) {	   
-	vrtemp = 255 * vrtemp / vltemp;    
-	vltemp = 255;  
+    vrtemp = 255 * vrtemp / vltemp;    
+    vltemp = 255;  
   }
   if (vrtemp < -255) {
     vltemp = -255 * vltemp / vrtemp;
@@ -153,8 +187,4 @@
   
   *vr = (int)vrtemp;
   *vl = (int)vltemp;
-	
-
 }
-
-
Index: branches/encoders/code/projects/libdragonfly/odometry.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/odometry.h	(nonexistent)
+++ branches/encoders/code/projects/libdragonfly/odometry.h	(revision 1345)
@@ -0,0 +1,56 @@
+
+/**
+ * @file odometry.h
+ * @brief Code for estimating the robots pose.
+ * 
+ * Offers simple position and orientation information.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
+#ifndef __ODOMETRY_C__
+#define __ODOMETRY_C__
+
+/**
+ * @addtogroup odometry 
+ * @{
+ **/
+
+//Odometry resolution, *64 microseconds.
+#define ODOMETRY_CLK 255u 
+#define TIME_SCALE 64
+
+//Wheel = 2.613 in.  
+//Circumference = 208.508133 mm
+//Distance per encoder click (circumference / 1024)  = 203.621224 um.
+//Robot width = 5.3745 in. = 136.5123 mm
+
+#define ROBOT_WIDTH_UM 137000  //um
+#define CLICK_DISTANCE_UM 204 //um
+
+#define DISTANCE_SCALE 2.10526316 //Magic constant.
+#define ANGLE_SCALE 1.12823207 //Magic constant.
+
+/** @brief Retrieve the robots estimated x position*/
+long odometry_dx(void);
+
+/** @brief Retrieve the robots estimated y position*/
+long odometry_dy(void);
+
+/** @brief Retrieve the robots estimated orientation*/
+double odometry_angle(void);
+
+/** @brief Initialize odometry. MUST be called before 
+ * the other functions work.**/
+void odometry_init(void);
+
+/** @brief Reset position and orientation to the origin facing
+ * the x axis.*/
+void odometry_reset(void);
+
+/** @brief Report estimated velocity [mm/s].*/
+long odometry_velocity(void);
+
+/**@}**/ //end group
+
+#endif
Index: branches/encoders/code/projects/libdragonfly/encoders.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/encoders.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/encoders.h	(revision 1345)
@@ -46,8 +46,13 @@
 #define MagINCn _BV(1)
 #define MagDECn _BV(0)
 
-#define BUFFER_SIZE 23
+//////////////////////////////
+//#define BUFFER_SIZE 23
+#define BUFFER_SIZE		46
+#define ERR_VEL			1024
+//////////////////////////////
 
+
 /** @brief Initialize encoders. **/
 void encoders_init(void);
 /** @brief Read instantaneous encoder value. **/
Index: branches/encoders/code/projects/libdragonfly/lcd.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/lcd.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/lcd.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file lcd.h
  * @brief Contains definitions for dealing with the LCD screen.
  * 
@@ -32,3 +58,4 @@
 /** @} **/
 
 #endif
+
Index: branches/encoders/code/projects/libdragonfly/battery.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/battery.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/battery.c	(revision 1345)
@@ -1,3 +1,38 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file battery.c
+ * @brief Implementation for reading battery level
+ *
+ * Contains functions for reading the battery level.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
 #include "battery.h"
 #include "analog.h"
 
@@ -67,7 +102,8 @@
   
   int batt_reading = battery8();
 
-  if(next_read == 0) {
+  if(next_read == 0) 
+  {
     if(batt_reading > BATTERY_LOWV)
     {
         ret = 0;
@@ -96,7 +132,7 @@
  * for convenience. analog_init must be called before this
  * function may be used.
  *
- * @param n_samples The number of times to sample the battery voltage
+ * @param n_samples the number of times to sample the battery voltage
  *
  * @return the average reading for the battery voltage, where 128
  * is approximately 5 Volts.
@@ -108,7 +144,8 @@
   int i;
   long int sum = 0;
   
-  for(i = 0; i < n_samples; i++) {
+  for(i = 0; i < n_samples; i++) 
+  {
     sum += battery8();
   }
   
